<?php
set_error_handler ('php_error_handler');
error_reporting (E_ALL | E_STRICT); ini_set ('display_errors', 1);
date_default_timezone_set ('Europe/Moscow');

ini_set ('memory_limit', '2048M'); gc_enable();
ini_set ('max_execution_time', 0);

/* * */

$correct_file_times_path = 'D:/Backup';
$incorrect_file_times_path = dirname (dirname (dirname (__FILE__)));

$book_maker = rglob ($correct_file_times_path, 'os2book-v*.cmd');

if (count ($book_maker) == 1) {
    $path_to_book_maker = dirname ($book_maker[0]); $files = rglob ($path_to_book_maker, '*');

    foreach ($files as $file_name) {
        $local_file_name = $incorrect_file_times_path.strreplace ($file_name, $path_to_book_maker, '');

        if (file_exists ($local_file_name)) {
            touch ($local_file_name, filectime ($file_name)); print $local_file_name."\n";
        }
    }
}

exit;

/* * */

function rglob ($path_w_slash, $pattern, $flags = 0) {
    if (substr ($path_w_slash, -1) != '/') $path_w_slash .= '/';

    $paths = glob ($path_w_slash.'*', GLOB_ONLYDIR);
    $files = glob ($path_w_slash.$pattern, $flags);

    foreach ($paths as $next_step_path) {
        $next_step_files = rglob ($next_step_path.'/', $pattern, $flags); 
        foreach ($next_step_files as $next_step_file) { $files[] = $next_step_file; }
    }

    return $files;
}

/* * */

function strreplace ($haystack, $needle, $str) { return str_replace ($needle, $str, $haystack); }
function yield_time () { if (function_exists ('proc_nice')) { proc_nice (abs (31)); } else { usleep (25); } }

function php_error_handler ($errno, $errstr, $errfile, $errline, $vars) { 
    die ("\n\n".'['.$errno.'] '.$errstr.' ('.strtr ($errfile, '\\', '/').', '.$errline.')'."\n\n");
}
